<template>
    <Form ref="form" v-slot="{ handleSubmit, values, meta }" :initialValues="initialValues">
         <div class="v-chart-account-form px-[40px] py-[30px]">
            <div class="grid gap-4 mb-4 md:grid-cols-3">
                <div>
                    <Field name="fullName" type="text" v-slot="{ value, errorMessage, handleChange }" filterable >
                        <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                            Branch <span class="sign">*</span></label>
                        <el-form-item :error="errorMessage">
                            <el-input :model-value="value" @update:model-value="handleChange" placeholder="Branch" />
                        </el-form-item>
                    </Field>
                </div>
                <div>
                    <Field name="companyId" type="text" v-slot="{ value, errorMessage, handleChange }" >
                        <label class="block mb-2 text-sm font-medium text-gray-900" for="contractId">ID No <span
                                class="sign">*</span>
                            <el-form-item :error="errorMessage">
                                <el-select :model-value="value" @update:model-value="handleChange" filterable
                                    class="w-[100%] mt-2" placeholder="Select a company" size="large" clearable>
                                    <el-option v-for="(item, i) in company" :key="i" :label="item.companyNameEn"
                                        :value="item.id" />
                                </el-select>
                            </el-form-item>
                        </label>
                    </Field>
                </div>
                <div>
                    <Field name="companySessionId" type="text" v-slot="{ value, errorMessage, handleChange }" 
                        :items="projects" filterable>
                        <label class="block text-sm font-medium text-gray-900">Name <span class="sign">*</span>
                            <el-form-item :error="errorMessage">
                                <el-select @change="onFetchVendor" :disabled="isReadonly" :model-value="value"
                                    @update:model-value="handleChange" class="w-[100%] mt-2" placeholder="Select a Abbreviation "
                                  size="large" clearable>
                                  <el-option v-for="(item, i) in company" :key="i" :label="item.companyNameEn" :value="item.id" />
                                </el-select>
                            </el-form-item>
                        </label>
                  </Field>
                </div> 
            </div>
             <div class="grid gap-4 mb-4 md:grid-cols-2">
             <div>
                <Field name="gender" type="checkList" :value="true" :unchecked-value="false"
                    v-slot="{ value, errorMessage, handleChange }">
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                        Collection  <span class="sign">*</span></label>
                    <el-form-item :error="errorMessage">
                        <el-checkbox label="1" :model-value="value" @update:model-value="handleChange" :disabled="isReadonly">
                            Penalty
                        </el-checkbox>
                        <el-checkbox  label="2" :model-value="value" @update:model-value="handleChange" :disabled="isReadonly">
                            Interest payment
                        </el-checkbox>
                        <el-checkbox label="3" :model-value="value" @update:model-value="handleChange" :disabled="isReadonly">
                            Extra principal
                        </el-checkbox>
                        <el-checkbox  label="4" :model-value="value" @update:model-value="handleChange" :disabled="isReadonly">
                            Final payment
                        </el-checkbox>
                        <el-checkbox  label="5" :model-value="value" @update:model-value="handleChange" :disabled="isReadonly">
                           Fee
                        </el-checkbox>
                        <el-checkbox label="6" :model-value="value" @update:model-value="handleChange" :disabled="isReadonly">
                            Over Final Payment
                        </el-checkbox>
                        <el-checkbox  label="7" :model-value="value" @update:model-value="handleChange" :disabled="isReadonly">
                            Other
                        </el-checkbox>
                    </el-form-item>
                </Field>
            </div>
        </div>    
            <div class="flex justify-center">
                <el-button v-if="!isReadonly" @click="handleSubmit($event, onSubmit(values, meta))"
                    class="bg-blue-700 hover:bg-blue-600 rounded-full ml-2 px-3 py-4 w-[100px]" size="large"
                    color="#1d4ed8">
                    Save
                </el-button>
            </div>
        </div>
    </Form>
  </template>
  <script>
  import {  ref } from "vue";
  import { Form, Field } from "vee-validate";
  
  export default {
    name: 'v-collection-form',
    components: {
        Field,
        Form,
    },
    props: {
        data: {
            type: Object,
            default: () => ({}),
        },
        isEdit: {
            type: Boolean,
            default: false,
        },
    },
  
    emits: ["submit"],
    setup(props, { emit }) {
        const form = ref();
        const initialValues = props?.data || {};
        const onSubmit = (values, meta) => {
            if (meta.valid) {
                emit("submit", values);
            }
        };
  
        return {
            initialValues,
            form,
            onSubmit,
        }
    }
  }
  </script>